<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE abiword PUBLIC "-//ABISOURCE//DTD AWML 1.0 Strict//EN" "http://www.abisource.com/awml.dtd">
<abiword template="false" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:svg="http://www.w3.org/2000/svg" xid-max="229" xmlns:dc="http://purl.org/dc/elements/1.1/" fileformat="1.1" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:awml="http://www.abisource.com/awml.dtd" xmlns="http://www.abisource.com/awml.dtd" xmlns:xlink="http://www.w3.org/1999/xlink" version="2.8.4" xml:space="preserve" props="dom-dir:ltr; document-footnote-restart-section:0; document-endnote-type:numeric; document-endnote-place-enddoc:1; document-endnote-initial:1; lang:en-US; document-endnote-restart-section:0; document-footnote-restart-page:0; document-footnote-type:numeric; document-footnote-initial:1; document-endnote-place-endsection:0">
<!-- ======================================================================== -->
<!-- This file is an AbiWord document.                                        -->
<!-- AbiWord is a free, Open Source word processor.                           -->
<!-- More information about AbiWord is available at http://www.abisource.com/ -->
<!-- You should not edit this file by hand.                                   -->
<!-- ======================================================================== -->

<metadata>
<m key="dc.format">application/x-abiword</m>
<m key="abiword.generator">AbiWord</m>
</metadata>
<styles>
<s type="P" name="Normal" followedby="Current Settings" props="font-family:Liberation Serif; margin-top:0pt; color:000000; margin-left:0pt; bgcolor:transparent; widows:2; font-style:normal; text-indent:0in; text-position:normal; margin-bottom:0pt; font-weight:normal; line-height:1.0; text-align:left; font-variant:normal; text-decoration:none; margin-right:0pt; font-size:12pt; font-stretch:normal"/>
</styles>
<pagesize pagetype="A4" orientation="portrait" width="210.000000" height="297.000000" units="mm" page-scale="1.000000"/>
<section xid="1">
<p style="Normal" xid="2" props="text-align:left; dom-dir:ltr">#Copyright (c) 2008, Media Modifications Ltd.</p>
<p style="Normal" xid="3" props="text-align:left; dom-dir:ltr">#Copyright (c) 2011, Walter Bender</p>
<p style="Normal" xid="4"><c></c></p>
<p style="Normal" xid="5" props="text-align:left; dom-dir:ltr"># This procedure is invoked when the user-definable block on the</p>
<p style="Normal" xid="6" props="text-align:left; dom-dir:ltr"># "extras" palette is selected.</p>
<p style="Normal" xid="7"><c></c></p>
<p style="Normal" xid="8" props="text-align:left; dom-dir:ltr"># Usage: Import this code into a Python (user-definable) block; Pass</p>
<p style="Normal" xid="9" props="text-align:left; dom-dir:ltr"># it 'start' to start recording; 'stop' to stop recording; 'play' to</p>
<p style="Normal" xid="10" props="text-align:left; dom-dir:ltr"># play back your recording; or 'save' to save your recording to the</p>
<p style="Normal" xid="11" props="text-align:left; dom-dir:ltr"># Sugar Journal.</p>
<p style="Normal" xid="12"><c></c></p>
<p style="Normal" xid="13"><c></c></p>
<p style="Normal" xid="14" props="text-align:left; dom-dir:ltr">def myblock(tw, arg):</p>
<p style="Normal" xid="15" props="text-align:left; dom-dir:ltr">    ''' Record and playback a sound (Sugar only) '''</p>
<p style="Normal" xid="16" props="text-align:left; dom-dir:ltr">    import os</p>
<p style="Normal" xid="17" props="text-align:left; dom-dir:ltr">    import time</p>
<p style="Normal" xid="18"><c></c></p>
<p style="Normal" xid="19" props="text-align:left; dom-dir:ltr">    import gtk</p>
<p style="Normal" xid="20" props="text-align:left; dom-dir:ltr">    import gst</p>
<p style="Normal" xid="21"><c></c></p>
<p style="Normal" xid="22" props="text-align:left; dom-dir:ltr">    import gobject</p>
<p style="Normal" xid="23" props="text-align:left; dom-dir:ltr">    gobject.threads_init()</p>
<p style="Normal" xid="24"><c></c></p>
<p style="Normal" xid="25" props="text-align:left; dom-dir:ltr">    from TurtleArt.tautils import get_path</p>
<p style="Normal" xid="26" props="text-align:left; dom-dir:ltr">    from TurtleArt.tagplay import play_audio_from_file</p>
<p style="Normal" xid="27" props="text-align:left; dom-dir:ltr">    from sugar.datastore import datastore</p>
<p style="Normal" xid="28" props="text-align:left; dom-dir:ltr">    from sugar import profile</p>
<p style="Normal" xid="29"><c></c></p>
<p style="Normal" xid="30" props="text-align:left; dom-dir:ltr">    from gettext import gettext as _</p>
<p style="Normal" xid="31"><c></c></p>
<p style="Normal" xid="32" props="text-align:left; dom-dir:ltr">    class Grecord:</p>
<p style="Normal" xid="33" props="text-align:left; dom-dir:ltr">        ''' A class for creating a gstreamer session for recording audio. '''</p>
<p style="Normal" xid="34"><c></c></p>
<p style="Normal" xid="35" props="text-align:left; dom-dir:ltr">        def __init__(self, tw):</p>
<p style="Normal" xid="36" props="text-align:left; dom-dir:ltr">            ''' Set up the stream. We save to a raw .wav file and then</p>
<p style="Normal" xid="37" props="text-align:left; dom-dir:ltr">            convert the sound to .ogg for saving. '''</p>
<p style="Normal" xid="38" props="text-align:left; dom-dir:ltr">            datapath = get_path(tw.parent, 'instance')</p>
<p style="Normal" xid="39" props="text-align:left; dom-dir:ltr">            self.capture_file = os.path.join(datapath, 'output.wav')</p>
<p style="Normal" xid="40" props="text-align:left; dom-dir:ltr">            self.save_file = os.path.join(datapath, 'output.ogg')</p>
<p style="Normal" xid="41" props="text-align:left; dom-dir:ltr">            self._eos_cb = None</p>
<p style="Normal" xid="42"><c></c></p>
<p style="Normal" xid="43" props="text-align:left; dom-dir:ltr">            self._can_limit_framerate = False</p>
<p style="Normal" xid="44" props="text-align:left; dom-dir:ltr">            self._recording = False</p>
<p style="Normal" xid="45"><c></c></p>
<p style="Normal" xid="46" props="text-align:left; dom-dir:ltr">            self._audio_transcode_handler = None</p>
<p style="Normal" xid="47" props="text-align:left; dom-dir:ltr">            self._transcode_id = None</p>
<p style="Normal" xid="48"><c></c></p>
<p style="Normal" xid="49" props="text-align:left; dom-dir:ltr">            self._pipeline = gst.Pipeline("Record")</p>
<p style="Normal" xid="50" props="text-align:left; dom-dir:ltr">            self._create_audiobin()</p>
<p style="Normal" xid="51" props="text-align:left; dom-dir:ltr">            self._pipeline.add(self._audiobin)</p>
<p style="Normal" xid="52"><c></c></p>
<p style="Normal" xid="53" props="text-align:left; dom-dir:ltr">            bus = self._pipeline.get_bus()</p>
<p style="Normal" xid="54" props="text-align:left; dom-dir:ltr">            bus.add_signal_watch()</p>
<p style="Normal" xid="55" props="text-align:left; dom-dir:ltr">            bus.connect('message', self._bus_message_handler)</p>
<p style="Normal" xid="56"><c></c></p>
<p style="Normal" xid="57" props="text-align:left; dom-dir:ltr">        def _create_audiobin(self):</p>
<p style="Normal" xid="58" props="text-align:left; dom-dir:ltr">            ''' Assemble all the pieces we need. '''</p>
<p style="Normal" xid="59" props="text-align:left; dom-dir:ltr">            src = gst.element_factory_make("alsasrc", "absrc")</p>
<p style="Normal" xid="60"><c></c></p>
<p style="Normal" xid="61" props="text-align:left; dom-dir:ltr">            # attempt to use direct access to the 0,0 device, solving some A/V</p>
<p style="Normal" xid="62" props="text-align:left; dom-dir:ltr">            # sync issues</p>
<p style="Normal" xid="63" props="text-align:left; dom-dir:ltr">            src.set_property("device", "plughw:0,0")</p>
<p style="Normal" xid="64" props="text-align:left; dom-dir:ltr">            hwdev_available = src.set_state(gst.STATE_PAUSED) != \</p>
<p style="Normal" xid="65" props="text-align:left; dom-dir:ltr">                              gst.STATE_CHANGE_FAILURE</p>
<p style="Normal" xid="66" props="text-align:left; dom-dir:ltr">            src.set_state(gst.STATE_NULL)</p>
<p style="Normal" xid="67" props="text-align:left; dom-dir:ltr">            if not hwdev_available:</p>
<p style="Normal" xid="68" props="text-align:left; dom-dir:ltr">                src.set_property("device", "default")</p>
<p style="Normal" xid="69"><c></c></p>
<p style="Normal" xid="70" props="text-align:left; dom-dir:ltr">            srccaps = gst.Caps("audio/x-raw-int,rate=16000,channels=1,depth=16")</p>
<p style="Normal" xid="71"><c></c></p>
<p style="Normal" xid="72" props="text-align:left; dom-dir:ltr">            # guarantee perfect stream, important for A/V sync</p>
<p style="Normal" xid="73" props="text-align:left; dom-dir:ltr">            rate = gst.element_factory_make("audiorate")</p>
<p style="Normal" xid="74"><c></c></p>
<p style="Normal" xid="75" props="text-align:left; dom-dir:ltr">            # without a buffer here, gstreamer struggles at the start of the</p>
<p style="Normal" xid="76" props="text-align:left; dom-dir:ltr">            # recording and then the A/V sync is bad for the whole video</p>
<p style="Normal" xid="77" props="text-align:left; dom-dir:ltr">            # (possibly a gstreamer/ALSA bug -- even if it gets caught up, it</p>
<p style="Normal" xid="78" props="text-align:left; dom-dir:ltr">            # should be able to resync without problem)</p>
<p style="Normal" xid="79" props="text-align:left; dom-dir:ltr">            queue = gst.element_factory_make("queue", "audioqueue")</p>
<p style="Normal" xid="80" props="text-align:left; dom-dir:ltr">            queue.set_property("leaky", True) # prefer fresh data</p>
<p style="Normal" xid="81" props="text-align:left; dom-dir:ltr">            queue.set_property("max-size-time", 5000000000) # 5 seconds</p>
<p style="Normal" xid="82" props="text-align:left; dom-dir:ltr">            queue.set_property("max-size-buffers", 500)</p>
<p style="Normal" xid="83" props="text-align:left; dom-dir:ltr">            queue.connect("overrun", self._log_queue_overrun)</p>
<p style="Normal" xid="84"><c></c></p>
<p style="Normal" xid="85" props="text-align:left; dom-dir:ltr">            enc = gst.element_factory_make("wavenc", "abenc")</p>
<p style="Normal" xid="86"><c></c></p>
<p style="Normal" xid="87" props="text-align:left; dom-dir:ltr">            sink = gst.element_factory_make("filesink", "absink")</p>
<p style="Normal" xid="88" props="text-align:left; dom-dir:ltr">            sink.set_property("location", self.capture_file)</p>
<p style="Normal" xid="89"><c></c></p>
<p style="Normal" xid="90" props="text-align:left; dom-dir:ltr">            self._audiobin = gst.Bin("audiobin")</p>
<p style="Normal" xid="91" props="text-align:left; dom-dir:ltr">            self._audiobin.add(src, rate, queue, enc, sink)</p>
<p style="Normal" xid="92"><c></c></p>
<p style="Normal" xid="93" props="text-align:left; dom-dir:ltr">            src.link(rate, srccaps)</p>
<p style="Normal" xid="94" props="text-align:left; dom-dir:ltr">            gst.element_link_many(rate, queue, enc, sink)</p>
<p style="Normal" xid="95"><c></c></p>
<p style="Normal" xid="96" props="text-align:left; dom-dir:ltr">        def _log_queue_overrun(self, queue):</p>
<p style="Normal" xid="97" props="text-align:left; dom-dir:ltr">            ''' We use a buffer, which may overflow. '''</p>
<p style="Normal" xid="98" props="text-align:left; dom-dir:ltr">            cbuffers = queue.get_property("current-level-buffers")</p>
<p style="Normal" xid="99" props="text-align:left; dom-dir:ltr">            cbytes = queue.get_property("current-level-bytes")</p>
<p style="Normal" xid="100" props="text-align:left; dom-dir:ltr">            ctime = queue.get_property("current-level-time")</p>
<p style="Normal" xid="101"> </p>
<p style="Normal" xid="102" props="text-align:left; dom-dir:ltr">        def is_recording(self):</p>
<p style="Normal" xid="103" props="text-align:left; dom-dir:ltr">            ''' Are we recording? '''</p>
<p style="Normal" xid="104" props="text-align:left; dom-dir:ltr">            return self._recording</p>
<p style="Normal" xid="105"><c></c></p>
<p style="Normal" xid="106" props="text-align:left; dom-dir:ltr">        def _get_state(self):</p>
<p style="Normal" xid="107" props="text-align:left; dom-dir:ltr">            ''' What is the state of our gstreamer pipeline? '''</p>
<p style="Normal" xid="108" props="text-align:left; dom-dir:ltr">            return self._pipeline.get_state()[1]</p>
<p style="Normal" xid="109"><c></c></p>
<p style="Normal" xid="110" props="text-align:left; dom-dir:ltr">        def start_recording_audio(self):</p>
<p style="Normal" xid="111" props="text-align:left; dom-dir:ltr">            ''' Start the stream in order to start recording. '''</p>
<p style="Normal" xid="112" props="text-align:left; dom-dir:ltr">            if self._get_state() == gst.STATE_PLAYING:</p>
<p style="Normal" xid="113" props="text-align:left; dom-dir:ltr">                return</p>
<p style="Normal" xid="114" props="text-align:left; dom-dir:ltr">            self._pipeline.set_state(gst.STATE_PLAYING)</p>
<p style="Normal" xid="115" props="text-align:left; dom-dir:ltr">            self._recording = True</p>
<p style="Normal" xid="116"><c></c></p>
<p style="Normal" xid="117" props="text-align:left; dom-dir:ltr">        def stop_recording_audio(self):</p>
<p style="Normal" xid="118" props="text-align:left; dom-dir:ltr">            ''' Stop recording and then convert the results into a</p>
<p style="Normal" xid="119" props="text-align:left; dom-dir:ltr">            .ogg file using a new stream. '''</p>
<p style="Normal" xid="120" props="text-align:left; dom-dir:ltr">            self._pipeline.set_state(gst.STATE_NULL)</p>
<p style="Normal" xid="121" props="text-align:left; dom-dir:ltr">            self._recording = False</p>
<p style="Normal" xid="122"><c></c></p>
<p style="Normal" xid="123" props="text-align:left; dom-dir:ltr">            if not os.path.exists(self.capture_file) or \</p>
<p style="Normal" xid="124" props="text-align:left; dom-dir:ltr">                   os.path.getsize(self.capture_file) &lt;= 0:</p>
<p style="Normal" xid="125" props="text-align:left; dom-dir:ltr">                return</p>
<p style="Normal" xid="126"><c></c></p>
<p style="Normal" xid="127" props="text-align:left; dom-dir:ltr">            # Remove previous transcoding results.</p>
<p style="Normal" xid="128" props="text-align:left; dom-dir:ltr">            if os.path.exists(self.save_file):</p>
<p style="Normal" xid="129" props="text-align:left; dom-dir:ltr">                os.remove(self.save_file)</p>
<p style="Normal" xid="130"><c></c></p>
<p style="Normal" xid="131" props="text-align:left; dom-dir:ltr">            line = 'filesrc location=' + self.capture_file + ' name=audioFilesrc ! wavparse name=audioWavparse ! audioconvert name=audioAudioconvert ! vorbisenc name=audioVorbisenc ! oggmux name=audioOggmux ! filesink name=audioFilesink'</p>
<p style="Normal" xid="132" props="text-align:left; dom-dir:ltr">            audioline = gst.parse_launch(line)</p>
<p style="Normal" xid="133"><c></c></p>
<p style="Normal" xid="134" props="text-align:left; dom-dir:ltr">            vorbis_enc = audioline.get_by_name('audioVorbisenc')</p>
<p style="Normal" xid="135"><c></c></p>
<p style="Normal" xid="136" props="text-align:left; dom-dir:ltr">            audioFilesink = audioline.get_by_name('audioFilesink')</p>
<p style="Normal" xid="137" props="text-align:left; dom-dir:ltr">            audioFilesink.set_property("location", self.save_file)</p>
<p style="Normal" xid="138"><c></c></p>
<p style="Normal" xid="139" props="text-align:left; dom-dir:ltr">            audioBus = audioline.get_bus()</p>
<p style="Normal" xid="140" props="text-align:left; dom-dir:ltr">            audioBus.add_signal_watch()</p>
<p style="Normal" xid="141" props="text-align:left; dom-dir:ltr">            self._audio_transcode_handler = audioBus.connect(</p>
<p style="Normal" xid="142" props="text-align:left; dom-dir:ltr">                'message', self._onMuxedAudioMessageCb, audioline)</p>
<p style="Normal" xid="143" props="text-align:left; dom-dir:ltr">            self._transcode_id = gobject.timeout_add(</p>
<p style="Normal" xid="144" props="text-align:left; dom-dir:ltr">                200, self._transcodeUpdateCb, audioline)</p>
<p style="Normal" xid="145" props="text-align:left; dom-dir:ltr">            audioline.set_state(gst.STATE_PLAYING)</p>
<p style="Normal" xid="146"><c></c></p>
<p style="Normal" xid="147" props="text-align:left; dom-dir:ltr">        def _transcodeUpdateCb(self, pipe):</p>
<p style="Normal" xid="148" props="text-align:left; dom-dir:ltr">            ''' Where are we in the transcoding process? '''</p>
<p style="Normal" xid="149" props="text-align:left; dom-dir:ltr">            position, duration = self._query_position(pipe)</p>
<p style="Normal" xid="150" props="text-align:left; dom-dir:ltr">            if position != gst.CLOCK_TIME_NONE:</p>
<p style="Normal" xid="151" props="text-align:left; dom-dir:ltr">                value = position * 100.0 / duration</p>
<p style="Normal" xid="152" props="text-align:left; dom-dir:ltr">                value = value/100.0</p>
<p style="Normal" xid="153" props="text-align:left; dom-dir:ltr">            return True</p>
<p style="Normal" xid="154"><c></c></p>
<p style="Normal" xid="155" props="text-align:left; dom-dir:ltr">        def _query_position(self, pipe):</p>
<p style="Normal" xid="156" props="text-align:left; dom-dir:ltr">            ''' Where are we in the stream? '''</p>
<p style="Normal" xid="157" props="text-align:left; dom-dir:ltr">            try:</p>
<p style="Normal" xid="158" props="text-align:left; dom-dir:ltr">                position, format = pipe.query_position(gst.FORMAT_TIME)</p>
<p style="Normal" xid="159" props="text-align:left; dom-dir:ltr">            except:</p>
<p style="Normal" xid="160" props="text-align:left; dom-dir:ltr">                position = gst.CLOCK_TIME_NONE</p>
<p style="Normal" xid="161"><c></c></p>
<p style="Normal" xid="162" props="text-align:left; dom-dir:ltr">            try:</p>
<p style="Normal" xid="163" props="text-align:left; dom-dir:ltr">                duration, format = pipe.query_duration(gst.FORMAT_TIME)</p>
<p style="Normal" xid="164" props="text-align:left; dom-dir:ltr">            except:</p>
<p style="Normal" xid="165" props="text-align:left; dom-dir:ltr">                duration = gst.CLOCK_TIME_NONE</p>
<p style="Normal" xid="166"><c></c></p>
<p style="Normal" xid="167" props="text-align:left; dom-dir:ltr">            return (position, duration)</p>
<p style="Normal" xid="168"><c></c></p>
<p style="Normal" xid="169" props="text-align:left; dom-dir:ltr">        def _onMuxedAudioMessageCb(self, bus, message, pipe):</p>
<p style="Normal" xid="170" props="text-align:left; dom-dir:ltr">            ''' Clean up at end of stream.'''</p>
<p style="Normal" xid="171" props="text-align:left; dom-dir:ltr">            if message.type != gst.MESSAGE_EOS:</p>
<p style="Normal" xid="172" props="text-align:left; dom-dir:ltr">                return True</p>
<p style="Normal" xid="173"><c></c></p>
<p style="Normal" xid="174" props="text-align:left; dom-dir:ltr">            gobject.source_remove(self._audio_transcode_handler)</p>
<p style="Normal" xid="175" props="text-align:left; dom-dir:ltr">            self._audio_transcode_handler = None</p>
<p style="Normal" xid="176" props="text-align:left; dom-dir:ltr">            gobject.source_remove(self._transcode_id)</p>
<p style="Normal" xid="177" props="text-align:left; dom-dir:ltr">            self._transcode_id = None</p>
<p style="Normal" xid="178" props="text-align:left; dom-dir:ltr">            pipe.set_state(gst.STATE_NULL)</p>
<p style="Normal" xid="179" props="text-align:left; dom-dir:ltr">            pipe.get_bus().remove_signal_watch()</p>
<p style="Normal" xid="180" props="text-align:left; dom-dir:ltr">            pipe.get_bus().disable_sync_message_emission()</p>
<p style="Normal" xid="181"><c></c></p>
<p style="Normal" xid="182" props="text-align:left; dom-dir:ltr">            os.remove(self.capture_file)</p>
<p style="Normal" xid="183" props="text-align:left; dom-dir:ltr">            return False</p>
<p style="Normal" xid="184"><c></c></p>
<p style="Normal" xid="185" props="text-align:left; dom-dir:ltr">        def _bus_message_handler(self, bus, message):</p>
<p style="Normal" xid="186" props="text-align:left; dom-dir:ltr">            ''' Handle any messages associated with the stream. '''</p>
<p style="Normal" xid="187" props="text-align:left; dom-dir:ltr">            t = message.type</p>
<p style="Normal" xid="188" props="text-align:left; dom-dir:ltr">            if t == gst.MESSAGE_EOS:</p>
<p style="Normal" xid="189" props="text-align:left; dom-dir:ltr">                if self._eos_cb:</p>
<p style="Normal" xid="190" props="text-align:left; dom-dir:ltr">                    cb = self._eos_cb</p>
<p style="Normal" xid="191" props="text-align:left; dom-dir:ltr">                    self._eos_cb = None</p>
<p style="Normal" xid="192" props="text-align:left; dom-dir:ltr">                    cb()</p>
<p style="Normal" xid="193" props="text-align:left; dom-dir:ltr">            elif t == gst.MESSAGE_ERROR:</p>
<p style="Normal" xid="194" props="text-align:left; dom-dir:ltr">                # TODO: if we come out of suspend/resume with errors, then</p>
<p style="Normal" xid="195" props="text-align:left; dom-dir:ltr">                # get us back up and running...  TODO: handle "No space</p>
<p style="Normal" xid="196" props="text-align:left; dom-dir:ltr">                # left on the resource.gstfilesink.c" err, debug =</p>
<p style="Normal" xid="197" props="text-align:left; dom-dir:ltr">                # message.parse_error()</p>
<p style="Normal" xid="198" props="text-align:left; dom-dir:ltr">                pass</p>
<p style="Normal" xid="199"><c></c></p>
<p style="Normal" xid="200" props="text-align:left; dom-dir:ltr">    # We store the audio-record stream instance as tw.grecord so that</p>
<p style="Normal" xid="201" props="text-align:left; dom-dir:ltr">    # we can use it repeatedly.</p>
<p style="Normal" xid="202" props="text-align:left; dom-dir:ltr">    if not hasattr(tw, 'grecord'):</p>
<p style="Normal" xid="203" props="text-align:left; dom-dir:ltr">        tw.grecord = Grecord(tw)</p>
<p style="Normal" xid="204"><c></c></p>
<p style="Normal" xid="205" props="text-align:left; dom-dir:ltr">    # Sometime we need to parse multiple arguments, e.g., save, savename</p>
<p style="Normal" xid="206" props="text-align:left; dom-dir:ltr">    save_name = _('Turtle Art') + ' ' + _('sound')</p>
<p style="Normal" xid="207" props="text-align:left; dom-dir:ltr">    if type(arg) == type([]):</p>
<p style="Normal" xid="208" props="text-align:left; dom-dir:ltr">        cmd = arg[0].lower()</p>
<p style="Normal" xid="209" props="text-align:left; dom-dir:ltr">        if len(arg) &gt; 1:</p>
<p style="Normal" xid="210" props="text-align:left; dom-dir:ltr">            save_name = str(arg[1])</p>
<p style="Normal" xid="211" props="text-align:left; dom-dir:ltr">    else:</p>
<p style="Normal" xid="212" props="text-align:left; dom-dir:ltr">        cmd = arg.lower()</p>
<p style="Normal" xid="213"><c></c></p>
<p style="Normal" xid="214" props="text-align:left; dom-dir:ltr">    if cmd == 'start' or cmd == _('start').lower():</p>
<p style="Normal" xid="215" props="text-align:left; dom-dir:ltr">        tw.grecord.start_recording_audio()</p>
<p style="Normal" xid="216" props="text-align:left; dom-dir:ltr">    elif cmd == 'stop' or cmd == _('stop').lower():</p>
<p style="Normal" xid="217" props="text-align:left; dom-dir:ltr">        tw.grecord.stop_recording_audio()</p>
<p style="Normal" xid="218" props="text-align:left; dom-dir:ltr">    elif cmd == 'play' or cmd == _('play').lower():</p>
<p style="Normal" xid="219" props="text-align:left; dom-dir:ltr">        play_audio_from_file(tw.lc, tw.grecord.save_file)</p>
<p style="Normal" xid="220" props="text-align:left; dom-dir:ltr">    elif cmd == 'save' or cmd == _('save').lower():</p>
<p style="Normal" xid="221" props="text-align:left; dom-dir:ltr">        if os.path.exists(tw.grecord.save_file) and tw.running_sugar:</p>
<p style="Normal" xid="222" props="text-align:left; dom-dir:ltr">            dsobject = datastore.create()</p>
<p style="Normal" xid="223" props="text-align:left; dom-dir:ltr">            dsobject.metadata['title'] = save_name</p>
<p style="Normal" xid="224" props="text-align:left; dom-dir:ltr">            dsobject.metadata['icon-color'] = profile.get_color().to_string()</p>
<p style="Normal" xid="225" props="text-align:left; dom-dir:ltr">            dsobject.metadata['mime_type'] = 'audio/ogg'</p>
<p style="Normal" xid="226" props="text-align:left; dom-dir:ltr">            dsobject.set_file_path(tw.grecord.save_file)</p>
<p style="Normal" xid="227" props="text-align:left; dom-dir:ltr">            datastore.write(dsobject)</p>
<p style="Normal" xid="228" props="text-align:left; dom-dir:ltr">            dsobject.destroy()</p>
<p style="Normal" xid="229"></p>
</section>
</abiword>
